
#ifndef _picture_h_
#define _picture_h_

/*
 *
 *          Copyright (C) 1995, M. A. Sridhar
 *  
 *
 *     This software is Copyright M. A. Sridhar, 1995. You are free
 *     to copy, modify or distribute this software  as you see fit,
 *     and to use  it  for  any  purpose, provided   this copyright
 *     notice and the following   disclaimer are included  with all
 *     copies.
 *
 *                        DISCLAIMER
 *
 *     The author makes no warranties, either expressed or implied,
 *     with respect  to  this  software, its  quality, performance,
 *     merchantability, or fitness for any particular purpose. This
 *     software is distributed  AS IS.  The  user of this  software
 *     assumes all risks  as to its quality  and performance. In no
 *     event shall the author be liable for any direct, indirect or
 *     consequential damages, even if the  author has been  advised
 *     as to the possibility of such damages.
 *
 */



#if defined(__GNUC__)
#pragma interface
#endif

#include "ui/color.h"
#include "ui/rectangl.h"

class YACL_UI UI_Picture ;

class UI_Picture {

public:
    UI_Picture (UI_VisualObject* parent, const UI_Rectangle& r, char[]) ;
    // Constructor: use this object's own model. The model will be
    // destroyed when this object is destroyed.

    //virtual UI_WindowClass WindowClass () const;
    
    const char* ClassName() const { return "UI_Picture";};

    void SetForeground(const UI_Color&) ;
    void SetBackground(const UI_Color&) ;

    ~UI_Picture();

protected:

    bool _DrawPicture ();

    UI_VisualObject* _parent ;
    
    char* _bmpbits           ;
    UI_Rectangle _bmprect    ;
    UI_Color _fgColor        ;
    UI_Color _bgColor        ;
    Bool     _fgChanged      ;
    Bool     _bgChanged      ;

};



#endif
